/********************************************************************************
 * Copyright (c) 2021-2024 Bayerische Motoren Werke Aktiengesellschaft (BMW AG)
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 ********************************************************************************/

#pragma once

{% for include in node.includes %}
#include {{include}}
{% endfor %}

{% block includes_special %}{% endblock %}

namespace {{ ose_namespace }}
{

class {{ node.umlClass.name }}
{
  public:
    struct Values
    {
        {% block implementation_values_special %}{% endblock %}
        {% for var in node.values %}
          {% if var.type.startswith('std::function') %}
            {{var.type}} Get{{var.name}};
          {% else %}
            {{var.type}} {{util.local(var)}};
          {% endif %}
        {% endfor %}
    };
    struct Interfaces
    {
        {% for var in node.blackboard_getter %}
        {{var.type}} {{util.local(var)}};
        {% endfor %}
    };

    {{ node.umlClass.name }}(Values values, Interfaces interfaces) :
        values{std::move(values)},
        mantle{std::move(interfaces)}
    {};

    bool IsSatisfied() const;

  private:
    Values values;
    Interfaces mantle;
};

}
